/**
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ReleasePR, ReleasePROptions } from '../release-pr';
import { ConventionalCommits } from '../conventional-commits';
import { VersionsMap } from '../updaters/update';
declare type BumpType = 'major' | 'minor' | 'patch' | 'snapshot';
export declare class Version {
    major: number;
    minor: number;
    patch: number;
    extra: string;
    snapshot: boolean;
    constructor(major: number, minor: number, patch: number, extra: string, snapshot: boolean);
    static parse(version: string): Version;
    bump(bumpType: BumpType): void;
    toString(): string;
}
export declare class JavaYoshi extends ReleasePR {
    constructor(options: ReleasePROptions);
    protected _run(): Promise<void>;
    protected defaultInitialVersion(): string;
    protected coerceVersions(cc: ConventionalCommits, currentVersions: VersionsMap): Promise<VersionsMap>;
    private coerceBumpType;
}
export {};
